﻿Imports SnippsCode.dsSnippsCode
Public Class frmDrop
    Private theSnippet As String
    Private f As New SnippFunction
    Private Declare Function RegisterHotKey Lib "user32" (ByVal hWnd As IntPtr, ByVal id As Integer, ByVal fsModifier As Integer, ByVal vk As Integer) As Integer
    Private Declare Sub UnregisterHotKey Lib "user32" (ByVal hWnd As IntPtr, ByVal id As Integer)
    Private Const Key_NONE As Integer = &H0
    Private Const Key_ALT As Integer = &H1
    Private Const WM_HOTKEY As Integer = &H312
    Private Sub frmDrop_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.Top = Screen.PrimaryScreen.WorkingArea.Height - Me.Height
        Me.Left = Screen.PrimaryScreen.WorkingArea.Width - Me.Width
        f.Load(DsSnippsCode)
        btnCopy.UseColumnTextForButtonValue = True
        RegisterHotKey(Me.Handle, 1, Key_ALT, Keys.F12)
        generateToolTips()
    End Sub
    Private Sub frmDrop_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        Me.Validate()
        Me.SuspendLayout()
        With Me.Controls
            While .Count > 0 : .Item(.Count - 1).Dispose() : End While
        End With
    End Sub
    Private Sub frmDrop_DragEnter(sender As Object, e As DragEventArgs) Handles Me.DragEnter
        If e.Data.GetDataPresent(DataFormats.Text) OrElse e.Data.GetDataPresent(DataFormats.Rtf) Then
            e.Effect = DragDropEffects.All
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub
    Private Sub frmDrop_DragDrop(sender As Object, e As DragEventArgs) Handles Me.DragDrop
        theSnippet = e.Data.GetData("Text", True).ToString
        Using fNew As New frmNew
            fNew.bsNewProjektFolder.DataSource = Dts
            fNew.bsNewProjektFile.DataSource = Dts
            Dim drv = DirectCast(fNew.bsNewProjektFile.AddNew(), DataRowView)
            Dim snp = DirectCast(drv.Row, ProjektDateiRow)
            snp.Inhalt = theSnippet
            snp.ProjektOrdnerRow = Dts.ProjektOrdner(0)
            If fNew.ShowDialog(Me) = DialogResult.OK Then
                fNew.bsNewProjektFile.EndEdit()
                Dim f As New SnippFunction
                f.Save(Dts)
            Else
                fNew.bsNewProjektFile.CancelEdit()
            End If
        End Using
    End Sub
    Private Sub dgvSnippet_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgvSnippets.CellClick
        If e.RowIndex < 0 OrElse e.RowIndex >= Me.bsFiles.Count Then Return
        If e.ColumnIndex <> 1 Then Return
        Dim drv = DirectCast(dgvSnippets.Rows(e.RowIndex).DataBoundItem, DataRowView)
        Dim snp = DirectCast(drv.Row, ProjektDateiRow)
        If Not snp.Inhalt = "" Then
            Clipboard.SetText(snp.Inhalt)
            niMain.Visible = True
            niMain.ShowBalloonTip(5)
            niMain.Visible = False
        Else
            niMain.BalloonTipText = "Diese Datei enthält keinen Inhalt !"
            niMain.Visible = True
            niMain.ShowBalloonTip(5)
            niMain.Visible = False
        End If
    End Sub
    Private Sub frmDrop_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        UnregisterHotKey(Me.Handle, 1)
    End Sub
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = WM_HOTKEY Then
            Me.Opacity = 1D - Me.Opacity
        End If
        MyBase.WndProc(m)
    End Sub
    Private Sub chkProjects_CheckedChanged(sender As Object, e As EventArgs) Handles chkProjects.CheckedChanged
        scProjects.Visible = chkProjects.Checked
    End Sub
    Private Sub btnReload_Click(sender As Object, e As EventArgs) Handles btnReload.Click
        f.Load(DsSnippsCode)
    End Sub
    Private Sub generateToolTips()
        Dim btnToolTip As New ToolTip
        btnToolTip.AutoPopDelay = 5000
        btnToolTip.InitialDelay = 500
        btnToolTip.ReshowDelay = 500
        btnToolTip.ShowAlways = True
        btnToolTip.SetToolTip(btnClose, "Zum Hauptmenü")
        btnToolTip.SetToolTip(chkProjects, "Projekte anzeigen")
        btnToolTip.SetToolTip(btnReload, "Daten neu laden")
    End Sub
End Class
